Difference between revisions of "Mesh to Part"

From FreeCAD Documentation
Jump to navigation Jump to search
m (template fr)
(Removed Docnav.)
 
(41 intermediate revisions by 7 users not shown)
Line 1: Line 1:
== Converting Part objects to Meshes ==
+
<languages/>
 +
<translate>
  
Converting higher-level objects such as [[Part Module|Part shapes]] into simpler objects such as [[Mesh Module|meshes]] is a pretty simple operation, where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh:
+
</translate>
 +
{{TOCright}}
 +
<translate>
  
#let's assume our document contains one part object
+
==Convert Part objects to meshes== <!--T:1-->
import Mesh
 
faces = []
 
shape = FreeCAD.ActiveDocument.ActiveObject.Shape
 
triangles = shape.tessellate(1) # the number represents the precision of the tessellation)
 
for tri in triangles[1]:
 
    face = []
 
    for i in range(3):
 
        vindex = tri[i]
 
        face.append(triangles[0][vindex])
 
    faces.append(face)
 
m = Mesh.Mesh(faces)
 
Mesh.show(m)
 
  
Sometimes the triangulation of certain faces offered by OpenCascade is quite ugly. If the face has a rectangular parameter space and doesn't contain any holes or other trimming curves you can also create a mesh on your own:
+
<!--T:2-->
 +
Converting higher-level objects such as [[Part Module|Part]] shapes to simpler objects such as [[Mesh Module|meshes]] is a pretty straightforward operation where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh:
  
import Mesh
+
</translate>
def makeMeshFromFace(u,v,face):
+
{{Code|code=
(a,b,c,d)=face.ParameterRange
+
import Mesh
pts=[]
 
for j in range(v):
 
for i in range(u):
 
s=1.0/(u-1)*(i*b+(u-1-i)*a)
 
t=1.0/(v-1)*(j*d+(v-1-j)*c)
 
pts.append(face.valueAt(s,t))
 
 
mesh=Mesh.Mesh()
 
for j in range(v-1):
 
for i in range(u-1):
 
mesh.addFacet(pts[u*j+i],pts[u*j+i+1],pts[u*(j+1)+i])
 
mesh.addFacet(pts[u*(j+1)+i],pts[u*j+i+1],pts[u*(j+1)+i+1])
 
 
return mesh
 
  
== Converting Meshes to Part objects ==
+
obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
 +
shp = obj.Shape
 +
faces = []
  
Converting Meshes to Part objects is an extremely important operation in CAD work, because very often you receive 3D data in mesh format from other people or outputted from other applications. Meshes are very practical to represent free-form geometry and big visual scenes, as it is very lightweight, but for CAD we generally prefer higher-level objects that carry much more information, such as the idea of solid, or faces made of curves instead of triangles.
+
triangles = shp.tessellate(1) # the number represents the precision of the tessellation
 +
for tri in triangles[1]:
 +
    face = []
 +
    for i in tri:
 +
        face.append(triangles[0][i])
 +
    faces.append(face)
  
Converting meshes to those higher-level objects (handled by the [[Part Module]] in FreeCAD) is not an easy operation. Meshes can be made of thousands of triangles (for example when generated by a 3D scanner), and having solids made of the same number of faces would be extremely heavy to manipulate. So you generally want to optimize the object when converting.
+
m = Mesh.Mesh(faces)
 +
Mesh.show(m)
 +
}}
 +
<translate>
  
FreeCAD currently offers two methods to convert Meshes to Part objects. The first method is a simple, direct conversion, without any optimization:
+
<!--T:17-->
 +
Alternative example:
  
import Mesh,Part
+
</translate>
mesh = Mesh.createTorus()
+
{{Code|code=
shape = Part.Shape()
+
import Mesh
shape.makeShapeFromMesh(mesh.Topology,0.05) # the second arg is the tolerance for sewing
+
import MeshPart
solid = Part.makeSolid(shape)
 
Part.show(solid)
 
  
The second method offers the possibility to consider mesh facets coplanar when the angle between them is under a certain value. This allows to build much simpler shapes:
+
obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
 +
shp = obj.Shape
  
# let's assume our document contains one Mesh object
+
mesh = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
import Mesh,Part,MeshPart
+
mesh.Mesh = MeshPart.meshFromShape(
faces = []
+
        Shape=shp,
mesh = App.ActiveDocument.ActiveObject.Mesh
+
        LinearDeflection=0.01,
segments = mesh.getPlanes(0.00001) # use rather strict tolerance here
+
        AngularDeflection=0.025,
+
        Relative=False)
for i in segments:
+
}}
  if len(i) > 0:
+
<translate>
      # a segment can have inner holes
 
      wires = MeshPart.wireFromSegment(mesh, i)
 
      # we assume that the exterior boundary is that one with the biggest bounding box
 
      if len(wires) > 0:
 
        ext=None
 
        max_length=0
 
        for i in wires:
 
            if i.BoundBox.DiagonalLength > max_length:
 
              max_length = i.BoundBox.DiagonalLength
 
              ext = i
 
 
        wires.remove(ext)
 
        # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
 
        for i in wires:
 
            i.reverse()
 
 
        # make sure that the exterior wires comes as first in the lsit
 
        wires.insert(0, ext)
 
        faces.append(Part.Face(wires))
 
 
shell=Part.Compound(faces)
 
Part.show(shell)
 
#solid = Part.Solid(Part.Shell(faces))
 
#Part.show(solid)
 
  
{{docnav|Topological data scripting|Scenegraph}}
+
==Convert meshes to Part objects== <!--T:4-->
  
{{languages | {{es|Mesh to Part/es}} {{fr|Mesh to Part/fr}} {{it|Mesh to Part/it}} {{ru|Mesh to Part/ru}} {{se|Mesh to Part/se}} }}
+
<!--T:5-->
 +
Converting meshes to Part objects is a common operation. Very often you will receive 3D data in a mesh format. Meshes are quite practical for representing free-form geometry and big visual scenes, as they are very lightweight. But in FreeCAD we generally prefer higher-level objects, solids, that can carry much more information and allow for curved faces.
  
[[Category:Poweruser Documentation]]
+
<!--T:6-->
[[Category:Python Code]]
+
Converting meshes to those higher-level objects (handled by the [[Part Module]] in FreeCAD) is not an easy operation. Meshes can contain thousands of triangles (for example when generated by a 3D scanner), and solids made of the same number of faces would be  extremely difficult to manipulate. So you generally want to optimize the object when converting.
 +
 
 +
<!--T:7-->
 +
FreeCAD currently offers two methods to convert meshes to Part objects. The first method is a simple, direct conversion without any optimization:
 +
 
 +
</translate>
 +
{{Code|code=
 +
import Mesh
 +
import Part
 +
 
 +
mesh = Mesh.createTorus()
 +
shape = Part.Shape()
 +
shape.makeShapeFromMesh(mesh.Topology, 0.05) # the second arg is the tolerance for sewing
 +
solid = Part.makeSolid(shape)
 +
Part.show(solid)
 +
}}
 +
<translate>
 +
 
 +
<!--T:8-->
 +
The second method offers the possibility to consider mesh facets co-planar when the angle between them is under a certain value, reducing the number of faces in the final result:
 +
 
 +
</translate>
 +
{{Code|code=
 +
import Mesh
 +
import Part
 +
import MeshPart
 +
 
 +
obj = FreeCADGui.Selection.getSelection()[0] # a Mesh object must be preselected
 +
mesh = obj.Mesh
 +
segments = mesh.getPlanarSegments(0.00001) # use rather strict tolerance here
 +
faces = []
 +
 
 +
for i in segments:
 +
    if len(i) > 0:
 +
        # a segment can have inner holes
 +
        wires = MeshPart.wireFromSegment(mesh, i)
 +
        # we assume that the exterior boundary is that one with the biggest bounding box
 +
        if len(wires) > 0:
 +
            ext = None
 +
            max_length=0
 +
            for i in wires:
 +
                if i.BoundBox.DiagonalLength > max_length:
 +
                    max_length = i.BoundBox.DiagonalLength
 +
                    ext = i
 +
 
 +
            wires.remove(ext)
 +
            # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
 +
            for i in wires:
 +
                i.reverse()
 +
 
 +
            # make sure that the exterior wires comes as first in the list
 +
            wires.insert(0, ext)
 +
            faces.append(Part.Face(wires))
 +
 
 +
solid = Part.Solid(Part.Shell(faces))
 +
Part.show(solid)
 +
}}
 +
<translate>
 +
 
 +
 
 +
</translate>
 +
{{Powerdocnavi{{#translation:}}}}
 +
[[Category:Developer Documentation{{#translation:}}]]
 +
[[Category:Python Code{{#translation:}}]]
 +
{{Mesh Tools navi{{#translation:}}}}
 +
{{clear}}

Latest revision as of 14:29, 20 August 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎svenska • ‎čeština • ‎русский • ‎日本語

Convert Part objects to meshes

Converting higher-level objects such as Part shapes to simpler objects such as meshes is a pretty straightforward operation where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh:

import Mesh

obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
shp = obj.Shape
faces = []

triangles = shp.tessellate(1) # the number represents the precision of the tessellation
for tri in triangles[1]:
    face = []
    for i in tri:
        face.append(triangles[0][i])
    faces.append(face)

m = Mesh.Mesh(faces)
Mesh.show(m)

Alternative example:

import Mesh
import MeshPart

obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
shp = obj.Shape

mesh = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
mesh.Mesh = MeshPart.meshFromShape(
        Shape=shp,
        LinearDeflection=0.01,
        AngularDeflection=0.025,
        Relative=False)

Convert meshes to Part objects

Converting meshes to Part objects is a common operation. Very often you will receive 3D data in a mesh format. Meshes are quite practical for representing free-form geometry and big visual scenes, as they are very lightweight. But in FreeCAD we generally prefer higher-level objects, solids, that can carry much more information and allow for curved faces.

Converting meshes to those higher-level objects (handled by the Part Module in FreeCAD) is not an easy operation. Meshes can contain thousands of triangles (for example when generated by a 3D scanner), and solids made of the same number of faces would be extremely difficult to manipulate. So you generally want to optimize the object when converting.

FreeCAD currently offers two methods to convert meshes to Part objects. The first method is a simple, direct conversion without any optimization:

import Mesh
import Part

mesh = Mesh.createTorus()
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology, 0.05) # the second arg is the tolerance for sewing
solid = Part.makeSolid(shape)
Part.show(solid)

The second method offers the possibility to consider mesh facets co-planar when the angle between them is under a certain value, reducing the number of faces in the final result:

import Mesh
import Part
import MeshPart

obj = FreeCADGui.Selection.getSelection()[0] # a Mesh object must be preselected
mesh = obj.Mesh
segments = mesh.getPlanarSegments(0.00001) # use rather strict tolerance here
faces = []

for i in segments:
    if len(i) > 0:
        # a segment can have inner holes
        wires = MeshPart.wireFromSegment(mesh, i)
        # we assume that the exterior boundary is that one with the biggest bounding box
        if len(wires) > 0:
            ext = None
            max_length=0
            for i in wires:
                if i.BoundBox.DiagonalLength > max_length:
                    max_length = i.BoundBox.DiagonalLength
                    ext = i

            wires.remove(ext)
            # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
            for i in wires:
                i.reverse()

            # make sure that the exterior wires comes as first in the list
            wires.insert(0, ext)
            faces.append(Part.Face(wires))

solid = Part.Solid(Part.Shell(faces))
Part.show(solid)